// Accordion
function accordion() {
  const accordionBtn = document.querySelectorAll(".adv-accordion--item__head");
  const accordionContent = document.querySelectorAll(
    ".adv-accordion--item__body"
  );

  accordionBtn.forEach((btn) => {
    btn.addEventListener("click", () => {
      const panel = btn.nextElementSibling;
      panel.classList.toggle("active");
      btn.classList.toggle("active");
    });
  });

  window.onclick = (e) => {
    if (!e.target.matches(".adv-accordion--item__head")) {
      accordionBtn.forEach((btn) => btn.classList.remove("active"));
      accordionContent.forEach((acc) => acc.classList.remove("active"));
    }
  };
}

// Modal
function modal() {
  const openModalGa4 = document.querySelectorAll(".open-popup-modal-ga4");
  const closeModalGa4 = document.querySelector("#close-popup-modal-ga4");
  const popUpModalGa4 = document.querySelector("#popup-modal-ga4");
  const openModalNl = document.querySelectorAll(".open-popup-modal-nl");
  const closeModalNl = document.querySelector("#close-popup-modal-nl");
  const popUpModalNl = document.querySelector("#popup-modal-nl");

  if (popUpModalGa4) {
    // Show modal
    openModalGa4.forEach((modal) => {
      modal.addEventListener("click", () => {
        popUpModalGa4.classList.add("show-popup-modal");
      });
    });

    // close modal
    closeModalGa4.addEventListener("click", () => {
      popUpModalGa4.classList.remove("show-popup-modal");
    });
  }

  if (popUpModalNl) {
    setTimeout(function () {
      popUpModalNl.classList.add("show-popup-modal");
    }, 1000);

    // close modal
    closeModalNl.addEventListener("click", () => {
      popUpModalNl.classList.remove("show-popup-modal");
    });
  }
}

// Mobile Menu
function mobileMenu() {
  const mobileMenuIcon = document.querySelector(".main-nav--menu-icon");
  const sidebarMenuIconAlt = document.querySelector(".main-nav--menu-icon-alt");
  const sidebarMenu = document.querySelector(".main-nav--sidebar");
  const mobileMenu = document.querySelector(".main-header--main-nav");
  const advertienceMenu = document.querySelector(".main-nav-advertience");

  if (advertienceMenu) {
    mobileMenuIcon.addEventListener("click", (e) => {
      mobileMenu.classList.toggle("main-header--main-nav__is-visible");
      mobileMenuIcon.classList.toggle("main-nav--menu-icon--close-x");
    });

    if (sidebarMenuIconAlt) {
      sidebarMenuIconAlt.addEventListener("click", (e) => {
        sidebarMenu.classList.toggle("main-nav--sidebar-is-visible");
        sidebarMenuIconAlt.classList.toggle("main-nav--menu-icon--close-x-alt");
      });
    }
  }
}
// Sticky Nav
function stickyNav() {
  const headerNav = document.querySelector(".main-header");
  const headerSpace = 14;
  let topOfNav = headerNav.offsetTop;

  if (headerNav) {
    function fixNav() {

      if (window.scrollY >= (topOfNav + headerSpace) ) {
        document.body.style.paddingTop = headerNav.offsetHeight + "px";
        document.body.classList.add("sticky-nav");
      } else {
        document.body.classList.remove("sticky-nav");
        document.body.style.paddingTop = 0;
      }
    }

    window.addEventListener("scroll", fixNav);
  }
}

// Form File Upload
function formFileUpload() {
  const careerForm = document.querySelector(".career-contact--content-form");
  const resumeLabel = document.querySelector(".career-resume-label");
  const coverLabel = document.querySelector(".career-cover-label");
  const resumeIcon = document.querySelector(".career-resume-icon");
  const coverIcon = document.querySelector(".career-cover-icon");
  const resumeInputWrap = document.querySelector(".applicant-resume");
  const coverInputWrap = document.querySelector(".applicant-cover");
  const resumeInput = document.querySelector("#career-resume");
  const coverInput = document.querySelector("#career-cover");

  const btnResumeClose = document.querySelector("#btn-resume-close");
  const btnCoverClose = document.querySelector("#btn-cover-close");

  if (careerForm) {
    resumeInputWrap.appendChild(resumeLabel);
    coverInputWrap.appendChild(coverLabel);
    resumeInputWrap.appendChild(resumeIcon);
    coverInputWrap.appendChild(coverIcon);
    resumeInputWrap.appendChild(btnResumeClose);
    coverInputWrap.appendChild(btnCoverClose);

    resumeInput.addEventListener("change", () => {
      if (resumeInput.files.length === 1) {
        resumeLabel.style.display = "none";
        resumeIcon.style.color = "#000";
        btnResumeClose.style.display = "block";
      } else {
        resumeLabel.style.display = "block";
        resumeIcon.style.color = "#666666";
        btnResumeClose.style.display = "none";
      }
    });

    coverInput.addEventListener("change", () => {
      if (coverInput.files.length === 1) {
        coverLabel.style.display = "none";
        coverIcon.style.color = "#000";
        btnCoverClose.style.display = "block";
      } else {
        coverLabel.style.display = "block";
        coverIcon.style.color = "#666666";
        btnCoverClose.style.display = "none";
      }
    });

    btnResumeClose.addEventListener("click", (e) => {
      e.preventDefault();
      resumeInput.value = null;
      resumeLabel.style.display = "block";
      resumeIcon.style.color = "#666666";
      btnResumeClose.style.display = "none";
    });

    btnCoverClose.addEventListener("click", (e) => {
      e.preventDefault();
      coverInput.value = null;
      coverLabel.style.display = "block";
      coverIcon.style.color = "#666666";
      btnCoverClose.style.display = "none";
    });
  }
}

function advTab() {
  const tabs = document.querySelector(".tabs");

  if (tabs) {
    const tabButtons = tabs.querySelectorAll('[role="tab"]');
    const tabPanels = Array.from(tabs.querySelectorAll('[role="tabpanel"]'));

    function handleTabClick(event) {
      // hide all tab panels
      tabPanels.forEach((panel) => {
        panel.hidden = true;
      });
      // mark all tabs as unselected
      tabButtons.forEach((tab) => {
        // tab.ariaSelected = false;
        tab.setAttribute("aria-selected", false);
        tab.setAttribute("class", "");
      });
      // mark the clicked tab as selected
      event.currentTarget.setAttribute("aria-selected", true);
      event.currentTarget.setAttribute("class", "active-tab");

      // find the associated tabPanel and show it!
      const { id } = event.currentTarget;

      // METHOD 2 - find in the array of tabPanels
      const tabPanel = tabPanels.find(
        (panel) => panel.getAttribute("aria-labelledby") === id
      );
      tabPanel.hidden = false;
    }

    tabButtons.forEach((button) =>
      button.addEventListener("click", handleTabClick)
    );
  }
}

// URL Builder
function urlBuilder() {
  urlGeneratorForm = document.querySelector(
    ".urlbuild-info--content-main-left__form"
  );

  if (urlGeneratorForm) {
    const websiteURL = document.querySelector("#website-url");
    const campaignSource = document.querySelector("#campaign-source");
    const campaignMedium = document.querySelector("#campaign-medium");
    const campaignName = document.querySelector("#campaign-name");
    const campaignTerm = document.querySelector("#campaign-term");
    const campaignContent = document.querySelector("#campaign-content");
    const campaignInput = document.querySelectorAll(".url-builder-input");
    const urlStatus = document.querySelector(
      ".adv-form-misc--status__url-status"
    );
    const urlOutput = document.querySelector(
      ".adv-form-misc--output__url-output"
    );
    const statusAlert = document.querySelector(".status-alert");
    const statusSuccess = document.querySelector(".status-success");

    function showStatus(msg, valStatus, el) {
      let newEl = document.createElement("p");

      urlStatus.innerHTML = "";

      if (valStatus === "alert") {
        newEl.classList.add("status-alert");
      } else if (valStatus === "success") {
        newEl.classList.add("status-success");
      }

      newEl.textContent = msg;
      urlStatus.style.display = "block";
      return urlStatus.appendChild(newEl);
    }

    campaignInput.forEach((input) => {
      input.addEventListener("keyup", () => {
        let urlOutputField;
        let baseOutputUrl;
        let mediumUrl;
        let nameUrl;

        if (websiteURL.value === "") {
          showStatus("Please fill in 'Website URL'.", "alert");
          urlOutput.value = "";
        } else if (campaignSource.value === "") {
          showStatus("Fill out required fields above.", "alert");
          urlOutput.value = "";
        }

        // URL + Source + Medium + Campaign Name
        if (
          websiteURL.value !== "" &&
          campaignSource.value !== "" &&
          campaignMedium.value !== "" &&
          campaignName.value !== ""
        ) {
          urlOutput.value = "";
          showStatus("Campaign URL Generated", "success");
          urlOutput.value = `${websiteURL.value}?utm_source=${campaignSource.value}&utm_medium=${campaignMedium.value}&utm_campaign=${campaignName.value}`;
        } else if (
          websiteURL.value === "" ||
          campaignSource.value === "" ||
          campaignMedium.value == "" ||
          campaignName.value === ""
        ) {
          showStatus("Fill out required fields above.", "alert");
          urlOutput.value = "";
        }

        // URL + Source + Medium + Campaign Name + Campaign Term
        if (
          websiteURL.value !== "" &&
          campaignSource.value !== "" &&
          campaignMedium.value !== "" &&
          campaignName.value !== "" &&
          campaignTerm.value !== ""
        ) {
          urlOutput.value = "";
          showStatus("Campaign URL Generated", "success");
          urlOutput.value = `${websiteURL.value}?utm_source=${campaignSource.value}&utm_medium=${campaignMedium.value}&utm_campaign=${campaignName.value}&utm_term=${campaignTerm.value}`;
        }

        // URL + Source + Medium + Campaign Name + Campaign Content
        if (
          websiteURL.value !== "" &&
          campaignSource.value !== "" &&
          campaignMedium.value !== "" &&
          campaignName.value !== "" &&
          campaignContent.value !== ""
        ) {
          urlOutput.value = "";
          showStatus("Campaign URL Generated", "success");
          urlOutput.value = `${websiteURL.value}?utm_source=${campaignSource.value}&utm_medium=${campaignMedium.value}&utm_campaign=${campaignName.value}&utm_content=${campaignContent.value}`;
        }

        // URL + Source + Medium + Campaign Name + Campaign Term + Campaign Content
        if (
          websiteURL.value !== "" &&
          campaignSource.value !== "" &&
          campaignMedium.value !== "" &&
          campaignName.value !== "" &&
          campaignTerm.value !== "" &&
          campaignContent.value !== ""
        ) {
          urlOutput.value = "";
          showStatus("Campaign URL Generated", "success");
          urlOutput.value = `${websiteURL.value}?utm_source=${campaignSource.value}&utm_medium=${campaignMedium.value}&utm_campaign=${campaignName.value}&utm_term=${campaignTerm.value}&utm_content=${campaignContent.value}`;
        }
      });
    });

    const btnCopy = document.querySelector("#btn-click-to-copy");
    const copyStatus = document.querySelector(".copy-status");

    btnCopy.addEventListener("click", (e) => {
      e.preventDefault();

      if (urlOutput.value === "") {
        copyStatus.innerText = "Nothing to copy";
      } else {
        urlOutput.select();
        urlOutput.setSelectionRange(0, 99999); /* For mobile devices */
        /* Copy the text inside the text field */
        navigator.clipboard.writeText(urlOutput.value);
        copyStatus.innerText = "Copied!";
      }
    });
  }
}

function ga4CountdownTimer() {
  const ga4Countdown = document.querySelector(".ga4-countdown");
  const ga4CountdownV2 = document.querySelector(".ga4-countdown-v2");
  var calcDay;

  if (ga4Countdown) {
    function countdown() {
      const countDate = new Date("July 1, 2023 00:00:00").getTime();
      const dateNow = new Date().getTime();
      const dateGap = countDate - dateNow;
      const yearIDays = 365;

      const second = 1000;
      const minute = second * 60;
      const hour = minute * 60;
      const day = hour * 24;

      calcDay = Math.floor(dateGap / day);
      const calcHour = Math.floor((dateGap % day) / hour);
      const calcMinute = Math.floor((dateGap % hour) / minute);
      const calcSecond = Math.floor((dateGap % minute) / second);

      const countdownSecondsEl = document.querySelector("#countdown-seconds");

      document.querySelector("#countdown-days").innerText = calcDay;
      document.querySelector("#countdown-hours").innerText =
        calcHour < 10 ? "0" + calcHour : calcHour;
      document.querySelector("#countdown-minutes").innerText =
        calcMinute < 10 ? "0" + calcMinute : calcMinute;

      if (countdownSecondsEl) {
        countdownSecondsEl.innerText =
          calcSecond < 10 ? "0" + calcSecond : calcSecond;
      }

      const dayPercentage = ((calcDay / yearIDays) * 100).toFixed(2);

      if (ga4CountdownV2) {
        const progressBar = document.querySelector(".circular-progress");

        let progressValue = 100 - dayPercentage;

        progressBar.style.background = `conic-gradient(
          #000000 ${progressValue * 3.6}deg,
          #19b7bc ${progressValue * 3.6}deg
        )`;
      }
    }
    setInterval(countdown, 1000);
  }

  setTimeout(() => {
    ga4CountdownV2.style.visibility = "visible";
  }, 1000);
}

function heroClickToScroll() {
  const scrollDownBtn = document.querySelector("#hero-click-scroll");
  const newsSingleScroll = document.querySelector("#section-updates-single-head-scroll");
  const mainHeaderHeight = document.querySelector(".main-header").offsetHeight;
  const scrollPosition = ((innerHeight - mainHeaderHeight) + 2)

  if (scrollDownBtn) {
    scrollDownBtn.addEventListener('click', (e) => {
      e.preventDefault();
      window.scrollTo(0, scrollPosition);
    })
  }

  if (newsSingleScroll) {
      window.scrollTo(0, 270);

  }
}

// main js loader
function runScripts() {
  mobileMenu();
  stickyNav();
  heroClickToScroll();
  // accordion();
  // modal();
  // formFileUpload();
  // advTab();
  // urlBuilder();
  // ga4CountdownTimer();
}

document.addEventListener("DOMContentLoaded", runScripts);

// $(".home-hero--wrap").slick({
//   dots: true,
//   autoplay: true,
//   autoplaySpeed: 5000,
//   fade: true,
//   cssEase: "linear",
//   arrows: false,
// });

// $(".services-section-one--wrap-slider").slick({
//   dots: true,
//   autoplay: true,
//   autoplaySpeed: 5000,
//   fade: true,
//   cssEase: "linear",
//   arrows: false,
// });

// $(".home-clients--wrap").slick({
//   slidesToShow: 5,
//   slidesToScroll: 1,
//   autoplaySpeed: 2000,
//   responsive: [
//     {
//       breakpoint: 1025,
//       settings: {
//         slidesToShow: 5,
//       },
//     },
//     {
//       breakpoint: 821,
//       settings: {
//         slidesToShow: 3,
//       },
//     },
//     {
//       breakpoint: 680,
//       settings: {
//         slidesToShow: 1,
//       },
//     },
//   ],
// });

// $(".home-leadership--wrap").slick({
//   fade: true,
//   cssEase: "linear",
// });

// $(".ssc-infographics-mobile--slider-wrap").slick({
//   dots: true,
// });

// $(".section-1-ga4-lp--content__img-2-mobile-wrap").slick({});

// $(".services-section-two--creative-slider-wrap").slick({
//   dots: false,
//   infinite: true,
// });

// $(".services-section-two--section-ggfnp-sl-body").slick({});

// $(".career-values--slider").slick({});
